#ifndef __DIALOGS_H_
#define __DIALOGS_H_

#define MAX_STRING_LENGTH  129

TCHAR pszAppName[] = TEXT("Applications Suite");
TCHAR pszTitle[] = TEXT("Applied Data System Applications Suite Ver 0.3");

/* Define child control command identifiers */

/* Define the global application HINSTANCE */
HINSTANCE ghInst;

int nWidth;  //Main window width
int nHeight; //Main window height

/* Define the HWNDs used by this application
   hwndMain --> Main application window
   hwndExit -> HWND of exit button
   hwndModalButton --> Button which
                          invokes modal dialog
   hwndModelessButton --> Button which
                          invokes modeless dialog
   hwndOpen --> HWND of the Open button
   hwndColor --> HWND of the Color button
   hwndModeless --> HWND of modeless dialog box
 */
HWND hwndMain=NULL;
HWND hwndExit=NULL;
HWND hwndModalButton=NULL;
HWND hwndModelessButton=NULL;
HWND hwndOpen=NULL;
HWND hwndColor=NULL;
HWND hwndModeless=NULL;
HWND hwndRotate=NULL;
HWND hwndRestartButton=NULL;
HWND hwndSpeaker=NULL;
HWND hEraseFxDisk=NULL;

void OnFileOpen(HWND hwnd);
void OnColor();
/* Define the main application window procedure */
LRESULT CALLBACK WndProc(HWND hwnd,
						 UINT message,
						 WPARAM wParam,
						 LPARAM lParam);

/* Define the dialog procedure for the
   sample modal dialog.
 */
BOOL CALLBACK ModalDlgProc(HWND hwndDlg,
                           UINT message,
                           WPARAM wParam,
                           LPARAM lParam);

/* Define the dialog procedure for the
   sample modeless dialog.
 */
extern BOOL CALLBACK TaskManagerDlgProc(HWND hwndDlg,
                              UINT message,
                              WPARAM wParam,
                              LPARAM lParam);

extern BOOL ReadSmscRegistry();
extern BOOL ReadAdsLoadRegistry1(void);
extern BOOL UpdateSmscRegistry();
extern void DeleteTempRegistryFile();
extern void WideToCharRegistry();

extern BOOL WriteADSLOADRegistry(void);
#endif
